/** @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rightChatItemHOC = exports.leftChatItemHOC = void 0;

var _rax = require("rax");

var _raxView = _interopRequireDefault(require("rax-view"));

var _raxText = _interopRequireDefault(require("rax-text"));

var _raxImage = _interopRequireDefault(require("rax-image"));

var _raxTbmsChatBase = require("rax-tbms-chat-base");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * @class
 * @name ChatItemHOC
 * @description 聊天消息项高阶函数
 */
var AVATOR_LEFT = 'https://gw.alicdn.com/tfs/TB1aRryvSzqK1RjSZFpXXakSXXa-640-640.png';
/**
 * 左侧(对方)消息高阶函数组件
 * - 内容区域 width: 448
 * @param {class} WrappedComponent
 * @memberof ChatItemHOC
 */

var leftChatItemHOC = function leftChatItemHOC(WrappedComponent) {
  return function (conversation) {
    var avator = conversation.touidAvator || AVATOR_LEFT; // 样式列表

    var style = {
      container: {
        flexDirection: 'row',
        justContent: 'flex-start',
        maxWidth: _raxTbmsChatBase.systemStyles.itemWidth,
        marginTop: _raxTbmsChatBase.systemStyles.itemMarginTop
      },
      containerAvator: {
        height: _raxTbmsChatBase.systemStyles.avatorRectangle,
        width: _raxTbmsChatBase.systemStyles.avatorRectangle,
        marginRight: _raxTbmsChatBase.systemStyles.avatorMarginRight,
        borderRadius: _raxTbmsChatBase.customStyles.border.avatorBorderRadius
      },
      containerCnt: {
        justifyContent: 'flex-start',
        maxWidth: _raxTbmsChatBase.systemStyles.itemMainWidth,
        overflow: 'hidden',
        display: 'inline-block'
      },
      containerWrapped: {
        borderRadius: _raxTbmsChatBase.customStyles.border.mainBorderRadius,
        borderWidth: _raxTbmsChatBase.customStyles.border.mainBorderWidth,
        borderColor: _raxTbmsChatBase.customStyles.border.mainBorderColor,
        color: _raxTbmsChatBase.customStyles.border.mainFontColor,
        paddingLeft: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingRight: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingTop: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingBottom: _raxTbmsChatBase.systemStyles.itemMainPadding,
        backgroundColor: _raxTbmsChatBase.systemStyles.itemBackgroundColor,
        marginTop: _raxTbmsChatBase.systemStyles.itemContentMarginTop,
        display: 'inline-block',
        textAlign: 'left'
      },
      containerWrappedCard: {
        paddingBottom: _raxTbmsChatBase.systemStyles.cardContainerPaddingBottom,
        display: 'inline-block'
      },
      containerNick: {
        fontSize: _raxTbmsChatBase.systemStyles.containerNickFontSize,
        color: _raxTbmsChatBase.systemStyles.containerNickFontColor,
        textAlign: 'left'
      }
    };
    return (
      /*#__PURE__*/
      function (_PureComponent) {
        _inherits(_class, _PureComponent);

        function _class() {
          _classCallCheck(this, _class);

          return _possibleConstructorReturn(this, _getPrototypeOf(_class).apply(this, arguments));
        }

        _createClass(_class, [{
          key: "renderPaddingContainer",
          value: function renderPaddingContainer() {
            return (0, _rax.createElement)(_raxView.default, {
              style: style.container
            }, (0, _rax.createElement)(_raxView.default, {
              style: style.containerAvator
            }, (0, _rax.createElement)(_raxImage.default, {
              source: {
                uri: avator
              },
              resizeMode: "cover",
              style: style.containerAvator
            })), (0, _rax.createElement)(_raxView.default, {
              style: [style.containerCnt, style.containerLeft]
            }, (0, _rax.createElement)(_raxText.default, {
              style: style.containerNick
            }, conversation.touid), (0, _rax.createElement)(_raxView.default, {
              style: [style.containerWrapped, this.props.isCard ? style.containerWrappedCard : null]
            }, (0, _rax.createElement)(WrappedComponent, this.props))));
          }
        }, {
          key: "renderFullContainer",
          value: function renderFullContainer() {
            return (0, _rax.createElement)(_raxView.default, {
              style: style.container
            }, (0, _rax.createElement)(_raxImage.default, {
              source: {
                uri: avator
              },
              resizeMode: "cover",
              style: style.containerAvator
            }), (0, _rax.createElement)(_raxView.default, {
              style: [style.containerCnt, style.containerLeft]
            }, (0, _rax.createElement)(_raxText.default, {
              style: style.containerNick
            }, conversation.touid), (0, _rax.createElement)(WrappedComponent, this.props)));
          }
        }, {
          key: "render",
          value: function render() {
            if (this.props.isFull) {
              return this.renderFullContainer();
            } else {
              return this.renderPaddingContainer();
            }
          }
        }]);

        return _class;
      }(_rax.PureComponent)
    );
  };
};
/**
 * 右侧(自己)消息高阶函数组件
 * @param {class} WrappedComponent
 * @memberof ChatItemHOC
 */


exports.leftChatItemHOC = leftChatItemHOC;

var rightChatItemHOC = function rightChatItemHOC(WrappedComponent) {
  return function (conversation) {
    var avator = conversation.uidAvator || AVATOR_LEFT; // 样式列表

    var style = {
      container: {
        flexDirection: 'row-reverse',
        justContent: 'flex-end',
        marginTop: _raxTbmsChatBase.systemStyles.itemMarginTop
      },
      containerAvatorRight: {
        marginLeft: _raxTbmsChatBase.systemStyles.avatorMarginRight
      },
      containerAvator: {
        height: _raxTbmsChatBase.systemStyles.avatorRectangle,
        width: _raxTbmsChatBase.systemStyles.avatorRectangle,
        borderRadius: _raxTbmsChatBase.customStyles.border.avatorBorderRadius,
        marginLeft: _raxTbmsChatBase.systemStyles.avatorMarginRight
      },
      containerCnt: {
        justifyContent: 'flex-end',
        maxWidth: _raxTbmsChatBase.systemStyles.itemMainWidth,
        overflow: 'hidden',
        display: 'inline-block',
        textAlign: 'right'
      },
      containerWrapped: {
        borderRadius: _raxTbmsChatBase.customStyles.border.mainBorderRadius,
        borderWidth: _raxTbmsChatBase.customStyles.border.mainBorderWidth,
        borderColor: _raxTbmsChatBase.customStyles.border.mainBorderColor,
        color: _raxTbmsChatBase.customStyles.border.mainFontColor,
        paddingLeft: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingRight: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingTop: _raxTbmsChatBase.systemStyles.itemMainPadding,
        paddingBottom: _raxTbmsChatBase.systemStyles.itemMainPadding,
        backgroundColor: _raxTbmsChatBase.customStyles.color.bubbleBackgroundColor,
        marginTop: _raxTbmsChatBase.systemStyles.itemContentMarginTop,
        display: 'inline-block'
      },
      containerWrappedCard: {
        paddingBottom: _raxTbmsChatBase.systemStyles.cardContainerPaddingBottom,
        display: 'inline-block'
      },
      containerNick: {
        fontSize: _raxTbmsChatBase.systemStyles.containerNickFontSize,
        color: _raxTbmsChatBase.systemStyles.containerNickFontColor,
        textAlign: 'right'
      }
    };
    return (
      /*#__PURE__*/
      function (_PureComponent2) {
        _inherits(_class2, _PureComponent2);

        function _class2() {
          _classCallCheck(this, _class2);

          return _possibleConstructorReturn(this, _getPrototypeOf(_class2).apply(this, arguments));
        }

        _createClass(_class2, [{
          key: "renderPaddingContainer",
          value: function renderPaddingContainer() {
            return (0, _rax.createElement)(_raxView.default, {
              style: style.container
            }, (0, _rax.createElement)(_raxView.default, null, (0, _rax.createElement)(_raxImage.default, {
              source: {
                uri: avator
              },
              resizeMode: "cover",
              style: style.containerAvator
            })), (0, _rax.createElement)(_raxView.default, {
              style: [style.containerCnt, style.containerRight]
            }, (0, _rax.createElement)(_raxText.default, {
              style: style.containerNick
            }, conversation.uid), (0, _rax.createElement)(_raxView.default, {
              style: [style.containerWrapped, this.props.isCard ? style.containerWrappedCard : null]
            }, (0, _rax.createElement)(WrappedComponent, this.props))));
          }
        }, {
          key: "renderFullContainer",
          value: function renderFullContainer() {
            return (0, _rax.createElement)(_raxView.default, {
              style: style.container
            }, (0, _rax.createElement)(_raxView.default, {
              style: [style.containerCnt, style.containerRight]
            }, (0, _rax.createElement)(_raxText.default, {
              style: style.containerNick
            }, conversation.uid), (0, _rax.createElement)(WrappedComponent, this.props)), (0, _rax.createElement)(_raxImage.default, {
              source: {
                uri: avator
              },
              resizeMode: "cover",
              style: style.containerAvator
            }));
          }
        }, {
          key: "render",
          value: function render() {
            if (this.props.isFull) {
              return this.renderFullContainer();
            } else {
              return this.renderPaddingContainer();
            }
          }
        }]);

        return _class2;
      }(_rax.PureComponent)
    );
  };
};

exports.rightChatItemHOC = rightChatItemHOC;